cdac.medinfo.sdk.hl7282.baselibs.segments

## Class TCD

- java.lang.Object
- - cdac.medinfo.sdk.hl7282.baselibs.segments.Segment
  - - cdac.medinfo.sdk.hl7282.baselibs.segments.TCD

- All Implemented Interfaces:
    ISegment

      public class TCD
      extends Segment

  TCD - Test Code Detail Segment.

  The test code detail (TCD)segment contains the data necessary to perform operations or calculations, or execute decisions by the laboratory automation system, and which are not supported by the original HL7 segments related to orders (ORC, OBR).

  Represents an HL7 TCD message segment. This segment has the following fields:

  TCD-1: Universal Service Identifier (CWE)Required
  TCD-2: Auto-Dilution Factor (SN)Optional
  TCD-3: Rerun Dilution Factor (SN)Optional
  TCD-4: Pre-Dilution Factor (SN)Optional
  TCD-5: Endogenous Content of Pre-Dilution Diluent (SN)Optional
  TCD-6: Automatic Repeat Allowed (ID)Optional
  TCD-7: Reflex Allowed (ID)Optional
  TCD-8: Analyte Repeat Status (CWE)Optional

  This class provides mechanism to validate message against HL7 v 2.8.2 standard. The class provides accessors & mutators for the elements mentioned above. The class has validate method which validates Message against HL7 v 2.8.2 standard.

  User can also create Segment through `SegmentFactory`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `TCD()` Constucts the TCD segment.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `CWE` | `getAnalyteRepeatStatus()` Retrieves the Analyte Repeat Status.
    `SN` | `getAuto_DilutionFactor()` Retrieves the Auto Dilution Factor.
    `ID` | `getAutomaticRepeatAllowed()` Retrieves the Automatic Repeat Allowed.
    `SN` | `getEndogenousContentofPre_DilutionDiluent()` Retrieves the Endogenous Content of Pre Dilution Diluent.
    `SN` | `getPre_DilutionFactor()` Retrieves the Pre Dilution Factor.
    `ID` | `getReflexAllowed()` Retrieves the Reflex Allowed.
    `SN` | `getRerunDilutionFactor()` Retrieves the Rerun Dilution Factor.
    `CWE` | `getUniversalServiceIdentifier()` Retrieves the Universal Service Identifier.
    `void` | `setAnalyteRepeatStatus(CWE objanalyteRepeatStatus)` Set the Analyte Repeat Status.
    `void` | `setAnalyteRepeatStatus(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Analyte Repeat Status.
    `void` | `setAuto_DilutionFactor(SN objauto_DilutionFactor)` Set the Auto Dilution Factor.
    `void` | `setAuto_DilutionFactor(java.lang.String strComparator, java.lang.String strNum1, java.lang.String strSeparatorSuffix, java.lang.String strNum2)` Set the Auto Dilution Factor.
    `void` | `setAutomaticRepeatAllowed(ID objautomaticRepeatAllowed)` Set the Automatic Repeat Allowed.
    `void` | `setAutomaticRepeatAllowed(java.lang.String strAutomaticRepeatAllowed)` Set the Automatic Repeat Allowed.
    `void` | `setEndogenousContentofPre_DilutionDiluent(SN objendogenousContentofPre_DilutionDiluent)` Set the Endogenous Content of Pre Dilution Diluent.
    `void` | `setEndogenousContentofPre_DilutionDiluent(java.lang.String strComparator, java.lang.String strNum1, java.lang.String strSeparatorSuffix, java.lang.String strNum2)` Set the Endogenous Content of Pre Dilution Diluent.
    `void` | `setPre_DilutionFactor(SN objpre_DilutionFactor)` Set the Pre Dilution Factor.
    `void` | `setPre_DilutionFactor(java.lang.String strComparator, java.lang.String strNum1, java.lang.String strSeparatorSuffix, java.lang.String strNum2)` Set the Pre Dilution Factor.
    `void` | `setReflexAllowed(ID objreflexAllowed)` Set the Reflex Allowed.
    `void` | `setReflexAllowed(java.lang.String strReflexAllowed)` Set the Reflex Allowed.
    `void` | `setRerunDilutionFactor(SN objrerunDilutionFactor)` Set the Rerun Dilution Factor.
    `void` | `setRerunDilutionFactor(java.lang.String strComparator, java.lang.String strNum1, java.lang.String strSeparatorSuffix, java.lang.String strNum2)` Set the Rerun Dilution Factor.
    `void` | `setUniversalServiceIdentifier(CWE objuniversalServiceIdentifier)` Set the Universal Service Identifier.
    `void` | `setUniversalServiceIdentifier(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Universal Service Identifier.
    `boolean` | `validate()` Validates HL7 Message objects .

    - ### Methods inherited from class cdac.medinfo.sdk.hl7282.baselibs.segments.Segment

      `addUnRecognizedField, dumpSegment, getFields, getName, getUnrecognizedFields, moveToNextSegment, parse, removeDataElement, removeDataElement, serialize, setName, setUnRecognizedField, updateDataElement, updateDataElement, writeToXML`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### TCD

          public TCD()

      Constucts the TCD segment.

  - ### Method Detail

    - #### getAnalyteRepeatStatus

          public CWE getAnalyteRepeatStatus()

      Retrieves the Analyte Repeat Status.
      Returns:
        CWE - analyteRepeatStatus

    - #### getAuto_DilutionFactor

          public SN getAuto_DilutionFactor()

      Retrieves the Auto Dilution Factor. This field specify that it is to be used as the factor for automatically diluting a particular specimen by an instrument for this particular test code.
      Returns:
        SN - auto_DilutionFactor

    - #### getAutomaticRepeatAllowed

          public ID getAutomaticRepeatAllowed()

      Retrieves the Automatic Repeat Allowed. This field identify whether automatic repeats are to be initiated for this particular specimen for this particular test code or not.
      Returns:
        ID - automaticRepeatAllowed

    - #### getEndogenousContentofPre_DilutionDiluent

          public SN getEndogenousContentofPre_DilutionDiluent()

      Retrieves the Endogenous Content of Pre Dilution Diluent.
      Returns:
        SN - endogenousContentofPre_DilutionDiluent

    - #### getPre_DilutionFactor

          public SN getPre_DilutionFactor()

      Retrieves the Pre Dilution Factor. This field specify that is to be used as the factor for a particular specimen that is delivered to the automated system as pre-diluted for this particular test code
      Returns:
        SN - pre_DilutionFactor

    - #### getReflexAllowed

          public ID getReflexAllowed()

      Retrieves the Reflex Allowed. This field identify whether automatic or manual reflex testing is to be initiated for this particular specimen or not.
      Returns:
        ID - reflexAllowed

    - #### getRerunDilutionFactor

          public SN getRerunDilutionFactor()

      Retrieves the Rerun Dilution Factor. This field specify that it is to be used as the factor for automatically diluting a particular specimen in case of rerun for this particular test code.
      Returns:
        SN - rerunDilutionFactor

    - #### getUniversalServiceIdentifier

          public CWE getUniversalServiceIdentifier()

      Retrieves the Universal Service Identifier.
      Returns:
        CWE - universalServiceIdentifier

    - #### setAnalyteRepeatStatus

          public void setAnalyteRepeatStatus(java.lang.String strIdentifier,
                                    java.lang.String strText,
                                    java.lang.String strNameOfCodingSystem,
                                    java.lang.String strAlternateIdentifier,
                                    java.lang.String strAlternateText,
                                    java.lang.String strNameOfAlternateCodingSystem,
                                    java.lang.String strCodingSystemVersionID,
                                    java.lang.String strAlternateCodingSystemVersionId,
                                    java.lang.String strOriginalText,
                                    java.lang.String strSecondAlternateIdentifier,
                                    java.lang.String strSecondAlternateText,
                                    java.lang.String strNameofSecondAlternateCodingSystem,
                                    java.lang.String strSecondAlternateCodingSystemVersionID,
                                    java.lang.String strCodingSystemOID,
                                    java.lang.String strValueSetOID,
                                    java.lang.String strValueSetVersionID,
                                    java.lang.String strAlternateCodingSystemOID,
                                    java.lang.String strAlternateValueSetOID,
                                    java.lang.String strAlternateValueSetVersionID,
                                    java.lang.String strSecondAlternateCodingSystemOID,
                                    java.lang.String strSecondAlternateValueSetOID,
                                    java.lang.String strSecondAlternateValueSetVersionID)

      Set the Analyte Repeat Status. This field identifies the repeat status for the analyte/result (e.g., original, rerun, repeat, reflex).
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setAnalyteRepeatStatus

          public void setAnalyteRepeatStatus(CWE objanalyteRepeatStatus)

      Set the Analyte Repeat Status. This field identifies the repeat status for the analyte/result (e.g., original, rerun, repeat, reflex).
      Parameters:
        `objanalyteRepeatStatus` - object of Analyte Repeat Status.

    - #### setAuto_DilutionFactor

          public void setAuto_DilutionFactor(java.lang.String strComparator,
                                    java.lang.String strNum1,
                                    java.lang.String strSeparatorSuffix,
                                    java.lang.String strNum2)

      Set the Auto Dilution Factor. This field specify that it is to be used as the factor for automatically diluting a particular specimen by an instrument for this particular test code.
      Parameters:
        `strComparator` - Specifies as greater than, less than, greater than or equal, less than or equal, equal, and not equal, respectively
        `strNum1` - Specifies A number.
        `strSeparatorSuffix` - Specifies Separat or Suffix
        `strNum2` - Specifies A number or null depending on the measurement.

    - #### setAuto_DilutionFactor

          public void setAuto_DilutionFactor(SN objauto_DilutionFactor)

      Set the Auto Dilution Factor. This field specify that it is to be used as the factor for automatically diluting a particular specimen by an instrument for this particular test code.
      Parameters:
        `objauto_DilutionFactor` - object of Auto_Dilution Factor.

    - #### setAutomaticRepeatAllowed

          public void setAutomaticRepeatAllowed(java.lang.String strAutomaticRepeatAllowed)

      Set the Automatic Repeat Allowed. This field identify whether automatic repeats are to be initiated for this particular specimen for this particular test code or not.
      Parameters:
        `strAutomaticRepeatAllowed` - This field contains the String Value of Automatic Repeat Allowed

    - #### setAutomaticRepeatAllowed

          public void setAutomaticRepeatAllowed(ID objautomaticRepeatAllowed)

      Set the Automatic Repeat Allowed. This field identify whether automatic repeats are to be initiated for this particular specimen for this particular test code or not.
      Parameters:
        `objautomaticRepeatAllowed` - object of Automatic Repeat Allowed.

    - #### setEndogenousContentofPre_DilutionDiluent

          public void setEndogenousContentofPre_DilutionDiluent(java.lang.String strComparator,
                                                       java.lang.String strNum1,
                                                       java.lang.String strSeparatorSuffix,
                                                       java.lang.String strNum2)

      Set the Endogenous Content of Pre Dilution Diluent.
      Parameters:
        `strComparator` - Specifies as greater than, less than, greater than or equal, less than or equal, equal, and not equal, respectively
        `strNum1` - Specifies A number.
        `strSeparatorSuffix` - Specifies Separat or Suffix
        `strNum2` - Specifies A number or null depending on the measurement.

    - #### setEndogenousContentofPre_DilutionDiluent

          public void setEndogenousContentofPre_DilutionDiluent(SN objendogenousContentofPre_DilutionDiluent)

      Set the Endogenous Content of Pre Dilution Diluent.
      Parameters:
        `objendogenousContentofPre_DilutionDiluent` - object of Endogenous Content of Pre_Dilution Diluent.

    - #### setPre_DilutionFactor

          public void setPre_DilutionFactor(java.lang.String strComparator,
                                   java.lang.String strNum1,
                                   java.lang.String strSeparatorSuffix,
                                   java.lang.String strNum2)

      Set the Pre Dilution Factor. This field specify that is to be used as the factor for a particular specimen that is delivered to the automated system as pre-diluted for this particular test code that is delivered to the automated system as pre-diluted for this particular test code
      Parameters:
        `strComparator` - Specifies as greater than, less than, greater than or equal, less than or equal, equal, and not equal, respectively
        `strNum1` - Specifies A number.
        `strSeparatorSuffix` - Specifies Separat or Suffix
        `strNum2` - Specifies A number or null depending on the measurement.

    - #### setPre_DilutionFactor

          public void setPre_DilutionFactor(SN objpre_DilutionFactor)

      Set the Pre Dilution Factor. This field specify that is to be used as the factor for a particular specimen that is delivered to the automated system as pre-diluted for this particular test code that is delivered to the automated system as pre-diluted for this particular test code
      Parameters:
        `objpre_DilutionFactor` - object of Pre_Dilution Factor.

    - #### setReflexAllowed

          public void setReflexAllowed(java.lang.String strReflexAllowed)

      Set the Reflex Allowed. This field identify whether automatic or manual reflex testing is to be initiated for this particular specimen or not.
      Parameters:
        `strReflexAllowed` - This field contains the String Value of Reflex Allowed

    - #### setReflexAllowed

          public void setReflexAllowed(ID objreflexAllowed)

      Set the Reflex Allowed. This field identify whether automatic or manual reflex testing is to be initiated for this particular specimen or not.
      Parameters:
        `objreflexAllowed` - object of Reflex Allowed.

    - #### setRerunDilutionFactor

          public void setRerunDilutionFactor(java.lang.String strComparator,
                                    java.lang.String strNum1,
                                    java.lang.String strSeparatorSuffix,
                                    java.lang.String strNum2)

      Set the Rerun Dilution Factor. This field specify that it is to be used as the factor for automatically diluting a particular specimen in case of rerun for this particular test code.
      Parameters:
        `strComparator` - Specifies as greater than, less than, greater than or equal, less than or equal, equal, and not equal, respectively
        `strNum1` - Specifies A number.
        `strSeparatorSuffix` - Specifies Separat or Suffix
        `strNum2` - Specifies A number or null depending on the measurement.

    - #### setRerunDilutionFactor

          public void setRerunDilutionFactor(SN objrerunDilutionFactor)

      Set the Rerun Dilution Factor. This field specify that it is to be used as the factor for automatically diluting a particular specimen in case of rerun for this particular test code.
      Parameters:
        `objrerunDilutionFactor` - object of Rerun Dilution Factor.

    - #### setUniversalServiceIdentifier

          public void setUniversalServiceIdentifier(java.lang.String strIdentifier,
                                           java.lang.String strText,
                                           java.lang.String strNameOfCodingSystem,
                                           java.lang.String strAlternateIdentifier,
                                           java.lang.String strAlternateText,
                                           java.lang.String strNameOfAlternateCodingSystem,
                                           java.lang.String strCodingSystemVersionID,
                                           java.lang.String strAlternateCodingSystemVersionId,
                                           java.lang.String strOriginalText,
                                           java.lang.String strSecondAlternateIdentifier,
                                           java.lang.String strSecondAlternateText,
                                           java.lang.String strNameofSecondAlternateCodingSystem,
                                           java.lang.String strSecondAlternateCodingSystemVersionID,
                                           java.lang.String strCodingSystemOID,
                                           java.lang.String strValueSetOID,
                                           java.lang.String strValueSetVersionID,
                                           java.lang.String strAlternateCodingSystemOID,
                                           java.lang.String strAlternateValueSetOID,
                                           java.lang.String strAlternateValueSetVersionID,
                                           java.lang.String strSecondAlternateCodingSystemOID,
                                           java.lang.String strSecondAlternateValueSetOID,
                                           java.lang.String strSecondAlternateValueSetVersionID)

      Set the Universal Service Identifier. This field identifies the test code that information is being transmitted about.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setUniversalServiceIdentifier

          public void setUniversalServiceIdentifier(CWE objuniversalServiceIdentifier)

      Set the Universal Service Identifier. This field identifies the test code that information is being transmitted about.
      Parameters:
        `objuniversalServiceIdentifier` - object of Universal Service Identifier.

    - #### validate

          public boolean validate()
                           throws InvalidSegmentException

      Validates HL7 Message objects . Validate method checks for validation each and every segments in side the Message object against specified message Structure. Validation chcecks include optionality of segment or group. It also verifies the number of times segment or group is repeated in message. e.g {PSH} while parsing PSH segment validate method will check for its mandatory presence. [PSH] in this case validate will throw exception if one tries to enter more than one PSH segment.
      Specified by:
        `validate` in interface `ISegment`
      Overrides:
        `validate` in class `Segment`
      Returns:
        boolean - true or false.
      Throws:
        `InvalidSegmentException` - Throws when Segment Validation fails.